'OSINFO.VBS
'v3.0  July 2004
'Jeffery Hicks
'jhicks@jhditsolutions.com	http://www.jhditsolutions.com
'USAGE: cscript|wscript WMIOSINFO.VBS
'DESCRIPTION:  Using WMI get operating system info for specified computer.  
'Includes code to display uptime.
'NOTES:  You must have admin rights on the queried system.  You will be 
'prompted for alternate credentials. But they can't be used on the local 
'system.

On Error Resume Next

Dim objLocator,objService,objRet
Dim objShell,objNetwork

Const wbemFlagReturnImmediately=&h10
Const wbemFlagForwardOnly=&h20

strTitle="OS Info"

strQuery="Select CSName,BootDevice,Caption,ServicePackMajorVersion," &_
"FreePhysicalMemory,FreeVirtualMemory,InstallDate,LastBootUpTime," &_
"Status,SystemDevice,TotalVirtualMemorySize,TotalVisibleMemorySize," &_
"Version,WindowsDirectory FROM Win32_OperatingSystem"

Set objShell=CreateObject("WScript.Shell")
Set objNetwork=CreateObject("wscript.network")

strSrv=InputBox("What computer do you want to query?",strTitle,_
objNetwork.ComputerName)
If strSrv="" Then WScript.Quit

'if not local system, then prompt for alternate credentials
If UCase(strSrv)<>UCase(objNetwork.ComputerName) Then
 strUser=InputBox("Enter an alternate credential account, or leave " &_
   "blank to use the current credentials.",strTitle,"")
  'if something was entered for strUser, then prompt for password
  
  If strUser<>"" Then
	 strPass=GetIEPassword()
  End If
End If

'if computer is accessible then get information
If TestPing(strSrv) Then

Set objLocator = CreateObject("WbemScripting.SWbemLocator")
If Err.Number <>0 then
	strMsg= "Error " & err.number & " [0x" & CStr(Hex(Err.Number)) &_
	 "] occurred in creating a locator object."
	
	If Err.Description <> "" Then
		strMsg=strMsg &VbCrLf & "Error description: " & Err.Description & "."
	End If

	objShell.Popup strMsg,10,strTitle,vbOKOnly+vbCritical
	Wscript.quit
End If

Set objService = objLocator.ConnectServer (strSrv,"root\cimv2",_
strUser,strPass)
ObjService.Security_.impersonationlevel = 3

Set objRet=objService.ExecQuery(strQuery,"WQL",wbemFlagForwardOnly+_
wbemFlagReturnImmediately)
If Err.Number<>0 Then
  strErrMsg= "Error executing query on " & UCase(strSrv) & VbCrLf
  strErrMsg= strErrMsg & "You might not have valid credentials." & VbCrLf
  strErrMsg= strErrMsg & "Error #" & err.number & " [0x" &_
 	CStr(Hex(Err.Number)) &"]" & VbCrLf
  If Err.Description <> "" Then
    strErrMsg = strErrMsg & "Error description: " & Err.Description & "."
  End If
  objShell.Popup strErrMsg,10,strTitle,vbOKOnly+vbExclamation
  wscript.quit
End If

For each item In objRet
 strInfo=item.CSNAME & vbCrlf
 strInfo=strInfo & item.Caption & " (" & item.Version & ")" & VbCrLf
 strInfo=strInfo & "Service Pack " & item.ServicePackMajorVersion & VbCrLf
 strInfo=strInfo & "Windows Directory: " & item.WindowsDirectory & vbCrlf
 strInfo=strInfo & "Boot Device: " & item.BootDevice & vbCrlf
 strInfo=strInfo & "System Device: " & item.SystemDevice & vbCrlf
 strInfo=strInfo & "Physical Memory: " &_
 FormatNumber(item.TotalVisibleMemorySize/1024,0) & "MB" & _
 " Total/" & FormatNumber(item.FreePhysicalMemory/1024,0) & "MB Free" &_
 " (" &_
 FormatPercent(item.FreePhysicalMemory/item.TotalVisibleMemorySize,0) &_
  ")" & VbCrLf
 
 strInfo=strInfo & "Virtual Memory: " & _
 FormatNumber(item.TotalVirtualMemorySize/1024,0) & "MB" & _
 " Total/" & FormatNumber(item.FreeVirtualMemory/1024,0) & "MB Free" & _
 " (" & FormatPercent(item.FreeVirtualMemory/item.TotalVirtualMemorySize,0)_
  & ")" & VbCrLf
 
 strInfo=strInfo & "Install Date: " & ConvWMITime(item.InstallDate) &_
  VbCrLf
 strInfo=strInfo & "Last Boot: " & ConvWMITime(item.LastBootUpTime) &_
  VbCrLf
	iDays=DateDiff("d",ConvWMITime(item.LastBootUpTime),Now)
	iHours=DateDiff("h",ConvWMITime(item.LastBootUpTime),Now)
	iMin=DateDiff("n",ConvWMITime(item.LastBootUpTime),Now)
	iSec=DateDiff("s",ConvWMITime(item.LastBootUpTime),Now)
	strUptime=iDays & " days " & (iHours Mod 24) & " hours " &_
	(iMin Mod 60) & " minutes " & (iSec Mod 60) & " seconds"
 strInfo=strInfo & "Uptime: " & strUptime & VbCrLf
 strInfo=strInfo & "Status: " & item.Status

Next

objShell.Popup strInfo,30,strTitle,vbOKOnly+vbInformation
strMsg="Do you want to save results to text file " & GetCurDir() &_
UCase(strSrv) & "_OSInfo.txt?" & VbCrLf &_
" Any existing file will be overwritten."
rc=MsgBox(strMsg,vbYesNo+vbQuestion,strTitle)
If rc=vbYes Then
	Dim objFSO,objFile
	Set objFSO=CreateObject("Scripting.FileSystemObject")
	Set objFile=objFSO.CreateTextFile(UCase(strSrv) & "_OSInfo.txt",True)
	objFile.Write strInfo
	objFile.WriteBlankLines(1)
	objFile.WriteLine "recorded " & Now
	objFile.Close
	objShell.Popup "Results saved to " & strSrv &_
	 "_OSInfo.txt",10,strTitle,vbOKOnly+vbinformation
End If


Else
strMsg="Failed to ping " & UCase(strSrv) & "."
objShell.Popup strMsg,10,strTitle,vbOKOnly+vbExclamation

End If

Wscript.quit
'End of main script

'///////////////////////////////////////////
' Convert WMI Time Function
'///////////////////////////////////////////
On Error Resume Next
Function ConvWMITime(wmiTime)

yr = left(wmiTime,4)
mo = mid(wmiTime,5,2)
dy = mid(wmiTime,7,2)
tm = mid(wmiTime,9,6)

ConvWMITime = mo&"/"&dy&"/"&yr & " " & FormatDateTime(left(tm,2) & _
":" & Mid(tm,3,2) & ":" & Right(tm,2),3)

End Function


'///////////////////////////////////////////
'Ping target system using WMI. Requires XP
' or Windows 2003 locally
'//////////////////////////////////////////
Function TestPing(strName)
On Error Resume Next
'this function requires Windows XP or 2003
Dim cPingResults, oPingResult
strPingQuery="SELECT * FROM Win32_PingStatus WHERE Address = '" &_
 strName & "'"

Set cPingResults = GetObject("winmgmts://./root/cimv2").ExecQuery(strPingQuery)
For Each oPingResult In cPingResults
	If oPingResult.StatusCode = 0 Then
		TestPing = True
	Else
		TestPing = False
	End If
Next
End Function

'///////////////////////////////////
'Use IE Password prompt
'to securely get a password
'//////////////////////////////////
Function GetIEPassword()
Dim ie
On Error Resume Next
set ie=Wscript.CreateObject("internetexplorer.application")
ie.width=400
ie.height=150
ie.statusbar=True
ie.menubar=False
ie.toolbar=False

ie.navigate ("About:blank")
ie.visible=True
ie.document.title="Password prompt"

strHTML=strHTML & "<Font color=RED><B>Enter password: <br>"_
&"<input id=pass type=Password></B></Font> &nbsp"
strHTML=strHTML & "<input type=checkbox id=Clicked size=1>"_
&"click box when finished"

ie.document.body.innerhtml=strHTML

Do While ie.busy<>False
	wscript.sleep 100
Loop

'loop until box is checked
 Do While ie.Document.all.clicked.checked=False
	WScript.Sleep 250
Loop

GetIEPassword=ie.Document.body.all.pass.value

ie.Quit
set ie=Nothing
End Function

'//////////////////////////////////////////////////////
'Get current path script is running in
'//////////////////////////////////////////////////////
Function GetCurDir()
On Error Resume Next
	GetCurDir=Left(WScript.ScriptFullName,Len(WScript.ScriptFullName)_
	-Len(WScript.ScriptName))
End Function

'EOF

