' NAME: ScriptFunctionLibrary.vbs 
' v1.4
' AUTHOR: Jeffery Hicks MCSE,MCT, MCSA
' jhicks@jdhitsolutions.com
' http://www.jdhitsolutions.com
' DATE  : September 2005
'
' NOTES : These functions are used in a variety of scripts And
' are meant to be called from a WSF file or copied and pasted
' into other scripts.

'//////////////////////////////////////////////////////
'Get current path script is running in
'//////////////////////////////////////////////////////
Function GetCurDir()
On Error Resume Next
    GetCurDir=Left(WScript.ScriptFullName,Len(WScript.ScriptFullName)_
    -Len(WScript.ScriptName))
End Function

'//////////////////////////////////////////////////////
'Generate a random number between two values
'//////////////////////////////////////////////////////
Function GetRand(iLower,iUpper)
Randomize
GetRand=Int((iUpper - iLower + 1) * Rnd + iLower)
End Function

'//////////////////////////////////////////////////////
'Functions to return padded timestamp that can be used in log file names
'output will be like 20040826140008
'//////////////////////////////////////////////////////
Function GetLogTime()
    Dim strNow
    strNow = Now()
    GetLogTime = Year(strNow) _
        & Pad(Month(strNow), 2, "0", True) _
        & Pad(Day(strNow), 2, "0", True) _
        & Pad(Hour(strNow), 2, "0", True) _
        & Pad(Minute(strNow), 2, "0", True) _
        & Pad(Second(strNow), 2, "0", True)
End Function 'GetLogTime()

Function Pad(strText, nLen, strChar, bFront)
Dim nStartLen
    If strChar = "" Then
        strChar = "0"
    End If
    nStartLen = Len(strText)
    If Len(strText) >= nLen Then
        Pad = strText
    Else
        If bFront Then
            Pad = String(nLen - Len(strText), strChar) _
                & strText
        Else
            Pad = strText & String(nLen - Len(strText), _
                strChar)
        End If
    End If
End Function

'///////////////////////////////////////////
'Object Exists Function
'//////////////////////////////////////////

Function ObjectExists(strADSPath)
On Error Resume Next
Dim objZTmp

ObjectExists=FALSE
set objZTmp=GetObject(strADSPath)
If Err.Number=0 Then ObjectExists=True

Set objZTmp=Nothing
End Function

'///////////////////////////////////////////
'User Object Exists Function
'//////////////////////////////////////////

Function UserExists(strDomain,strSAM)
On Error Resume Next
Dim objZTmp

ObjectExists=False
set objZTmp=GetObject("WinNT://"&strDomain&"/"&strSAM& ",user")
If Err.Number=0 Then ObjectExists=True
Err.Clear
Set objZTmp=Nothing
End Function


'\\\\\\\\\\\\\\\\\\\\\\
'ChkEngine Function
' return whether Cscript or wscript were used to execute a script
'\\\\\\\\\\\\\\\\\\\\\\
Function ChkEngine()
'returns either cscript.exe or wscript.exe
ON ERROR RESUME NEXT

strEngine=Wscript.FullName

if Err.Number <>0 then
 wscript.echo "Error!"
  wscript.echo "Error (" & Err.Number & ") Description: " &_
   Err.Description
  wscript.quit
end if

PosX=InStrRev(strEngine,"\",-1,vbTextCompare)
ChkEngine=LCase(Mid(strEngine,PosX+1))

End Function

'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
' Get user's distinguishedname
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
Function GetDN(samAccount)
'Given NT4 account name, find the distinguished name for the user account
On Error Resume Next
Dim conn,cmd,RS
Set conn=CreateObject("ADODB.Connection")
Set cmd=CreateObject("ADODB.Command")

GetDN="NotFound"

Set RootDSE=GetObject("LDAP://RootDSE")
Set myDomain=GetObject("LDAP://"&RootDSE.get("DefaultNamingContext"))

strQuery="Select sAMAccountname,distinguishedname from '" & _
myDomain.AdsPath & "' Where objectcategory='person' AND objectclass='user'" & _
" AND sAMAccountName='" & samAccount & "'"

set cat=GetObject("GC:")
for each obj In cat
 set GC=obj
Next

conn.Provider="ADSDSOObject"
conn.Open "Active Directory Provider"
cmd.ActiveConnection=conn
cmd.Properties("Page Size") = 100
cmd.Properties("asynchronous")=True
cmd.Properties("Timeout") =30
cmd.Properties("Cache Results") = false
cmd.CommandText=strQuery

set RS=cmd.Execute 

do while not RS.EOF
 GetDN=rs.Fields("distinguishedname")
 rs.movenext
Loop
rs.Close
conn.Close  

set conn=Nothing
set cmd=Nothing
set RootDSE=Nothing
set cat=Nothing
set RS=Nothing
End Function

'///////////////////////////////////////////
'Convert UTC time to standard time
'//////////////////////////////////////////

Function UndoZulu(strDate,offset)
On Error Resume Next
yr=Left(strDate,2)
mo=Mid(strDate,3,2)
dy=Mid(strDate,5,2)
hr=Mid(strDate,7,2)
mn=Mid(strDate,9,2)
sc=Mid(strDate,11,2)

dCreated=CDate(mo&"/"&dy&"/"&yr & " " & hr & ":" &mn & ":" & sc)
'wscript.Echo strDate & " is " & dCreated & " UTC"
UndoZulu=DateAdd("h",iOffset, dCreated)

End Function

'///////////////////////////////////////////
'Convert standard time stamp to UTC format
'//////////////////////////////////////////

Function ConvertToUTC(strDate,iOffset)
On Error Resume Next
strUTC=Right(Year(strDate),2)&Pad(Month(strDate),2,"0",True) &_
 Pad(Day(strDate),2,"0",True) & Pad(Hour(strDate),2,"0",True) &_
 Pad(Minute(strDate),2,"0",True) & Pad(Second(strDate),2,"0",True)
'ConvertToUTC=DateAdd("h",strUTC,iOffSet)
ConvertToUTC=strUTC

End Function

'////////////////////////////////////
'Convert WMI Time stamp
'///////////////////////////////////
Function ConvWMITime(wmiTime)
On Error Resume Next

yr = left(wmiTime,4)
mo = mid(wmiTime,5,2)
dy = mid(wmiTime,7,2)
tm = mid(wmiTime,9,6)

ConvWMITime = mo&"/"&dy&"/"&yr & " " & FormatDateTime(left(tm,2) & _
":" & Mid(tm,3,2) & ":" & Right(tm,2),3)
End Function

'///////////////////////////////////////////
'Ping target system using WMI. Requires XP
' or Windows 2003 locally
'//////////////////////////////////////////
Function TestPing(strName)
On Error Resume Next
'this function requires Windows XP or 2003
Dim cPingResults, oPingResult
strPingQuery="SELECT * FROM Win32_PingStatus WHERE Address = '" & strName & "'"

Set cPingResults = GetObject("winmgmts://./root/cimv2").ExecQuery(strPingQuery)
For Each oPingResult In cPingResults
    If oPingResult.StatusCode = 0 Then
        TestPing = True
    Else
        TestPing = False
    End If
Next
End Function

'///////////////////////////////////////////
'returns values like:
'Microsoft Windows XP Professional
'///////////////////////////////////////////
Function GetOS()
On Error Resume Next
Dim objWMI

Set objWMI=GetObject("winmgmts://.\root\cimv2").InstancesOf("win32_operatingsystem")

For Each OS In objWMI
  GetOS=OS.Caption
Next

End Function

'///////////////////////////////////
'Use IE Password prompt
'to securely get a password
'//////////////////////////////////
Function GetIEPassword()
Dim ie
On Error Resume Next
set ie=Wscript.CreateObject("internetexplorer.application")
ie.width=400
ie.height=150
ie.statusbar=True
ie.menubar=False
ie.toolbar=False

ie.navigate ("About:blank")
ie.visible=True
ie.document.title="Password prompt"

strHTML=strHTML & "<Font color=RED><B>Enter password: <br><input id=pass type=Password></B></Font> &nbsp"
strHTML=strHTML & "<input type=checkbox id=Clicked size=1>click box when finished"

ie.document.body.innerhtml=strHTML

Do While ie.busy<>False
    wscript.sleep 100
Loop

'loop until box is checked
 Do While ie.Document.all.clicked.checked=False
    WScript.Sleep 250
Loop

GetIEPassword=ie.Document.body.all.pass.value

ie.Quit
set ie=Nothing
End Function
'EOF