
'update an Access database with all AD computers
'and their current service pack version

'NOTE: See UpdateDB subroutine; expects an ODBC DSN
'to be defined.

'connect to the root of AD
Dim rootDSE, domainObject
Set rootDSE=GetObject("LDAP://RootDSE")
domainContainer = rootDSE.Get("defaultNamingContext")
Set oDomain = GetObject("LDAP://" & domainContainer)

'start with the domain root
WorkWithObject(oDomain)

Sub WorkWithObject(oContainer)
 Dim oADObject
 For Each oADObject in oContainer
  Select Case oADObject.Class
  
   Case "computer"
    'oADObject represents a COMPUTER object;
    'get the service pack version and log
    'it to the database
    Dim strComputer
    strComputer = oADObject.cn
    WScript.Echo strComputer
    UpdateDB strComputer, GetSPVer(strComputer)
	
   Case "organizationalUnit" , "container"
    'oADObject is an OU or container...
    'go through its objects
    WorkWithObject(oADObject)
  End select
 Next
End Sub

Sub UpdateDB(strComputer, strSPVer)
	Dim objConn, objRS, strSQL
	Set objConn = CreateObject("ADODB.Connection")
	objConn.Open "ServicePackDB"
	
	'see if computer exists in database
	Set objRS = objConn.Execute("SELECT ComputerName FROM Computers " & _
	 "WHERE ComputerName = '" & strComputer & "'")
	If objRS.EOF And objRS.BOF Then
		'computer not in database = add
		strSQL = "INSERT INTO Computers (ComputerName," & _
		 "ServicePackVersion,LastCheck) VALUES(" & _
		 "'" & strComputer & "'," & _
		 "'" & strSPVer & "'," & _
		 "#" & FormatDateTime(Now,2) & "#)"
	Else
		'computer in database = update
		strSQL = "UPDATE Computers SET " & _
		 "ServicePackVersion = '" & strSPVer & "', " & _
		 "LastCheck = #" & FormatDateTime(Now,2) & "# " & _
		 "WHERE ComputerName = '" & strComputer & "'"
	End If
	objRS.Close
	objConn.Execute strSQL
	objConn.Close
End Sub

Function GetSPVer(strComputer)
	On Error Resume Next
	Dim objWMIService
	Dim propValue
	Dim objItem
	Dim SWBemlocator
	Dim colItems
	Dim strSPVer
	Set SWBemlocator = CreateObject("WbemScripting.SWbemLocator")
	Set objWMIService = SWBemlocator.ConnectServer(strComputer, _
	 "\root\CIMV2")
	Set colItems = objWMIService.ExecQuery("Select * " & _
	 "from Win32_OperatingSystem",,48)
	For Each objItem in colItems
		strSPVer= objItem.ServicePackMajorVersion & "." & _
		 objItem.ServicePackMinorVersion
	Next
	GetSPVer = strSPVer
End Function
