Dim strUser, objGroupList, strGroup
Dim objRootDSE, strDNSDomain, objCmd, objCn
Dim strBase, strAttributes

' Get a user object.
strUser = "cn=TestUser,ou=it,dc=company,dc=pri"

' Specify group DN and check for membership.
strGroup = "cn=Admins,ou=it,dc=company,dc=pri"
If IsMember(strGroup) Then
	'is a member
Else
	'is not a member
End If

Function IsMember(strGroup)
' Function to test group membership.
' strGroup is the Distinguished Name of the group.
  If IsEmpty(objGroupList) Then
    Set objGroupList = CreateObject("Scripting.Dictionary")
    objGroupList.CompareMode = vbTextCompare

    ' Get DNS domain name.
    Set objRootDSE = GetObject("LDAP://RootDSE")
    strDNSDomain = objRootDSE.Get("DefaultNamingContext")

    ' Search Active Directory.
    Set objCmd = CreateObject("ADODB.Command")
    Set objCn = CreateObject("ADODB.Connection")
    objCn.Provider = "ADsDSOObject"
    objCn.Open "Active Directory Provider"
    objCmd.ActiveConnection = objCn
    strBase = "<GC://" & strDNSDomain & ">"
    strAttributes = "distinguishedName"
    objCmd.Properties("Page Size") = 100
    objCmd.Properties("Timeout") = 30
    objCmd.Properties("Cache Results") = False

    Call LoadGroups("(member=" & strUser & ")")
    objCn.Close
  End If
  IsMember = objGroupList.Exists(strGroup)
End Function

Sub LoadGroups(strMemberFilter)
  Dim strFilter, strQuery, strDN, objRecordSet
  Dim strNextFilter, blnRecurse

  strFilter = "(&(objectCategory=Group)" & strMemberFilter & ")"
  strQuery = strBase & ";" & strFilter & ";" & strAttributes & ";subtree"
  objCmd.CommandText = strQuery
  Set objRecordSet = objCmd.Execute
  strNextFilter = "(|"
  blnRecurse = False

  Do Until objRecordSet.EOF
    strDN = objRecordSet.Fields("DistinguishedName")
    If Not objGroupList.Exists(strDN) Then
      objGroupList(strDN) = True
      strNextFilter = strNextFilter & "(member=" & strDN & ")"
      blnRecurse = True
    End If
    objRecordSet.MoveNext
  Loop
  If blnRecurse = True Then
    strNextFilter = strNextFilter & ")"
    Call LoadGroups(strNextFilter)
  End If
End Sub
