@echo off
::SysPeek.bat
::USAGE- syspeek [computer]

::DESC- Build HTML page of system resource usage for specified computer.  
::Default html filename is computernameInfo.htm and it is created in the
::same directory you run the script from. If you don't specify a 
::computer, script will default to local host.  

::Information gathered:
::  Processor
::  OS
::	pagefile
::	memory
::	logical drives
::	services
::	processes

::IMPORTANT NOTES- This script uses a command line version of WMI that is 
::only available on Windows XP and 2003 platforms. Before you can run the
::script you must install WMIC. Open a command prompt and type 'WMIC' 
::which will start the installation. When it is finished you will have an
::interactive prompt (wmic:root\cli>). Type 'exit'. You can now run this 
::script.  The computer you are querying doesn't need WMIC but it must be
::WMI-enabled.

::You must have appropriate credentials on the target computer. You can 
::specify alternate credentials, but you will need to use the /USER and 
::/PASSWORD global switches. Run wmic /? at a command prompt to see help
::screens.

::You can build your own format files (.xsl) if you understand XML.  The
::files are found in %systemroot%\system32\wbem.  

:Top
::script version used in output
set zver=v2.0

 if "%1"=="" goto :Local
 set zSrv=%1
 goto :Main

:Local
 set zSrv=%computername%

:Main
 echo Getting system resource information for "%zSrv%"

::Define file for html output
 set zOutput=%zSrv%-Info.htm

::delete file if it already exists
 if exist %zOutput% del %zOutPut% >NUL
::delete error log if it previously exists
 if exist %zSrv%-Error.log del %zSrv%-Error.log >NUL

::build a shell html file.  Not required but I wanted to try.
 echo ^<html^> >> %zOutput%
 echo ^<body^> >> %zOutput%
 echo ^<H3^>^<Font Face=Verdana Color=Blue^>^<P align=Center^>%zSrv%^<BR^> >>%zOutput%
 echo System Resources Information^</Font^>^</H3^>^</P^> >>%zOutput%
 echo ^<HR^> >>%zOutput%
 echo ^</html^> >> %zOutput%
 echo ^</body^> >> %zOutput%

::verify connectivity and WMI compatibility
wmic /node:"%zSrv%" os list brief 1>NUL 2>> %zSrv%-Error.log
if errorlevel=0 goto :Gather
echo ^<Font Color=Red^>^<B^> OOPS!! ^</P^>>> %zOutPut%
echo Can't verify connectivity to or WMI compatibility with "%zSrv%" ^</P^> >> %zOutPut%
for /f "tokens=*" %%i in (%zSrv%-Error.log) do @echo %%i ^<br^> >>%zoutPut%
echo ^</Font^>^</B^> ^</P^> >> %zOutPUt%
goto :Cleanup

:Gather
::start gathering information.  WMIC command must be on one line.
 echo  OS...
 echo ^<Font Color=Green^>^<H3^>^<B^>^<I^>Operating System^</Font^>^</H3^>^</B^>^</I^> >> %zOutPut%
 wmic /node:"%zSrv%" /append:"%zOutPut%" OS get Caption,Version,CSDVersion,installDate,LastBootUpTime,Status,WindowsDirectory /format:hform.xsl >NUL
 
 echo  processor...
 echo ^<Font Color=Green^>^<H3^>^<B^>^<I^>Processors^</Font^>^</H3^>^</B^>^</I^> >> %zOutPut%
 wmic /node:"%zSrv%" /append:"%zOutPut%" cpu get deviceID,name,addresswidth,currentclockspeed,l2cachesize,loadpercentage /format:htable.xsl >NUL

 echo  memory...
 echo ^<Font Color=Green^>^<H3^>^<B^>^<I^>Memory^</Font^>^</H3^>^</B^>^</I^> >> %zOutPut%
 wmic /node:"%zSrv%" /append:"%zOutPut%" memlogical get AvailableVirtualMemory, TotalVirtualMemory, TotalPhysicalMemory, TotalPageFileSpace /format:hform.xsl >NUL

 echo  pagefile...
 echo ^<Font Color=Green^>^<H3^>^<B^>^<I^>PageFile^</Font^>^</H3^>^</B^>^</I^> >> %zOutPut%
 wmic /node:"%zSrv%" /append:"%zOutPut%" pagefileset get name, initialsize, maximumsize /format:hform.xsl >NUL
 wmic /node:"%zSrv%" /append:"%zOutPut%" pagefile get Caption, CurrentUsage, PeakUsage, InstallDate /format:hform.xsl >NUL

 echo  logical drives...
 echo ^<Font Color=Green^>^<H3^>^<B^>^<I^>Drive Information^</Font^>^</H3^>^</B^>^</I^> >> %zOutPut%
 wmic /node:"%zSrv%" /append:"%zOutPut%" logicaldisk where drivetype=3 get name, size, freespace, compressed, filesystem /format:htable.xsl >NUL

 echo  process...
 echo ^<Font Color=Green^>^<H3^>^<B^>^<I^>Processes^</Font^>^</H3^>^</B^>^</I^> >> %zOutPut%
 wmic /node:"%zSrv%" /append:"%zOutPut%" process list brief /format:"htable.xsl":"sortby=Name" >NUL

 echo  service...
 echo ^<Font Color=Green^>^<H3^>^<B^>^<I^>Services^</Font^>^</H3^>^</B^>^</I^> >> %zOutPut%
 wmic /node:"%zSrv%" /append:"%zOutPut%" service where startmode!="disabled" get pathname, state, startmode, displayname, processid /format:"htable.xsl":"sortby=State" >NUL

:Cleanup
 echo ^<I^>^<Font Size=-1^>^<BR^>%zver% >>%zOutput%
 date /t >>%zOutput%
 time /t >>%zOutput%
 echo - %username% ^</I^>>>%zOutput%

 echo Open %zOutPut% to view results
 Start %zOutPut%

 if exist %zSrv%-Error.log del %zSrv%-Error.log >NUL
 
 set zSrv=
 set zOutput=
 set zVer=

::EOF