'MasterExchange.vbs
'usage: cscript MasterExchange.vbs
'You must have Exchange Management tools installed in order
'to run this script.

arrServers=GetExchangeServers

For s = 0 To UBound(arrServers)-1
    WScript.Echo "*****Server Information*****"
    ExchangeServerInfo arrServers(s)
    WScript.Echo "*****Server Status*****"
    ExchangeServerState arrServers(s),"",""
    WScript.Echo "*****Service Status*****"
    GetServiceStatus arrServers(s)
    WScript.Echo "*****Queue Status*****"
    GetQueueInfo arrServers(s)
    WScript.Echo "*****Storage Groups*****"
    GetStorageGroups arrServers(s)
    WScript.Echo "*****Public Folders*****"
    GetPublicFolderInfo arrServers(s),"",""
Next
WScript.quit
'/////////////////////////////////////////////////////////////
Function GetExchangeServers()
' Find all servers in AD
'Returns an array of Exchange server names
WScript.Echo "Querying Active Directory for Exchange servers"
Dim objRootDSE
Dim objConfiguration
Dim cat
Dim conn
Dim cmd
Dim RS
Set objRootDSE = GetObject("LDAP://rootDSE")

strConfiguration = "LDAP://" & objRootDSE.Get("configurationNamingContext")
Set objConfiguration = GetObject(strConfiguration)

'select Exchange servers but not policies which share the same class
strQuery="Select distinguishedname,name from '" & _
objConfiguration.ADSPath & "' Where objectclass='msExchExchangeServer' " &_
"AND objectclass<>'msExchExchangeServerPolicy'"

strResults=""
Set cat=GetObject("GC:")
For each obj In cat
 Set GC=obj
Next

AdsPath=GC.ADSPath

Set conn=CreateObject("ADODB.Connection")
Set cmd=CreateObject("ADODB.Command")
conn.Provider="ADSDSOObject"
conn.Open   

Set cmd.ActiveConnection=conn
Set RS=conn.Execute(strQuery)
Do while not RS.EOF
 strResults=strResults & rs.Fields("name")&  ";"
 RS.movenext
Loop
RS.Close
conn.Close  
            
GetExchangeServers=Split(strResults,";")

End Function

Sub GetStorageGroups(strServer)
'Get list of Storage Groups on specified server
Dim objRootDSE
Dim objConfiguration
Dim conn
Dim cmd
Dim RS

Set objRootDSE = GetObject("LDAP://rootDSE")
strConfiguration = "LDAP://" & objRootDSE.Get("configurationNamingContext")
Set objConfiguration = GetObject(strConfiguration)
strPath=objConfiguration.ADSpath

strQuery="Select distinguishedname,name,whencreated from '" & strPath &_
 "' WHERE objectclass='msExchStorageGroup'"

set cat=GetObject("GC:")
for each obj in cat
 set GC=obj
Next

set conn=Createobject("ADODB.Connection")
set cmd=CreateObject("ADODB.Command")
conn.Provider="ADSDSOObject"
conn.Open   

set cmd.ActiveConnection=conn
set RS=conn.Execute(strQuery)
do while not RS.EOF
 If InStr(UCase(RS.Fields("distinguishedname")),UCase(strServer)) then
   WScript.echo RS.Fields("name") & "(Created " &_
    rs.fields("whencreated") & ")"
   SGReport strServer,RS.Fields("name")
 End If
 rs.movenext
Loop
rs.Close
conn.Close  

End Sub

Sub ExchangeServerInfo(strSrv)
Set objWMIService = GetObject("winmgmts:\\" & strSrv &_
 "\root\MicrosoftExchangev2")
Set colItems = objWMIService.ExecQuery("Select AdministrativeGroup,DN," &_
"ExchangeVersion,FQDN,Name,RoutingGroup,CreationTime,Name," &_
"IsFrontEndServer,MessageTrackingEnabled,SubjectLoggingEnabled," &_
"LastModificationTime from Exchange_Server where name='" & strSrv &_
 "'",,48)
 
For Each objItem In colItems
  If objItem.FQDN="" Then 
 WScript.echo "Failed to get Exchange server information from WMI." &_
 " Verify the Microsoft Exchange Management service is running on " &_
 strSRV 
Else
 wscript.echo UCase(objItem.FQDN) & " [" &_
 objItem.Exchangeversion & "]"
 wscript.echo "Administrative Group: " &_
  objItem.AdministrativeGroup 
 wscript.echo "Last modified: " &_
  ConvertTime(objItem.LastModificationTime)
 WScript.echo "Front End Server: " & objItem.IsFrontEndServer 
 wscript.echo "Message Tracking: " & objItem.MessageTrackingEnabled 
 WScript.echo "Subject logging: " & objItem.SubjectLoggingEnabled  
End If
Next
End Sub

Function ConvertTime(strTime)
On Error Resume Next

yr = Left(strTime,4)
mo = mid(strTime,5,2)
dy = mid(strTime,7,2)
tm = Mid(strTime,9,6)

ConvertTime=mo & "/" & dy & "/" & yr

End Function

Sub ExchangeServerState(strComputer,UserName,Password)
Dim objWMIService
Dim propValue
Dim objItem
Dim SWBemlocator
Dim colItems

Set SWBemlocator = CreateObject("WbemScripting.SWbemLocator")
Set objWMIService = SWBemlocator.ConnectServer(strComputer,_
"\root\cimv2\applications\exchange",UserName,Password)
strQuery="Select * from ExchangeServerState"
Set colItems = objWMIService.ExecQuery(strQuery,,48)
For Each objItem in colItems
  WScript.Echo "ClusterState: " & objItem.ClusterState
  WScript.Echo "ClusterStateString: " & objItem.ClusterStateString
  WScript.Echo "CPUState: " & objItem.CPUState
  WScript.Echo "CPUStateString: " & objItem.CPUStateString
  WScript.Echo "DisksState: " & objItem.DisksState
  WScript.Echo "DisksStateString: " & objItem.DisksStateString
  WScript.Echo "DN: " & objItem.DN
  WScript.Echo "GroupDN: " & objItem.GroupDN
  WScript.Echo "GroupGUID: " & objItem.GroupGUID
  WScript.Echo "GUID: " & objItem.GUID
  WScript.Echo "MemoryState: " & objItem.MemoryState
  WScript.Echo "MemoryStateString: " & objItem.MemoryStateString
  WScript.Echo "Name: " & objItem.Name
  WScript.Echo "QueuesState: " & objItem.QueuesState
  WScript.Echo "QueuesStateString: " & objItem.QueuesStateString
  WScript.Echo "ServerMaintenance: " & objItem.ServerMaintenance
  WScript.Echo "ServerState: " & objItem.ServerState
  WScript.Echo "ServerStateString: " & objItem.ServerStateString
  WScript.Echo "ServicesState: " & objItem.ServicesState
  WScript.Echo "ServicesStateString: " & objItem.ServicesStateString
  WScript.Echo "Unreachable: " & objItem.Unreachable
  WScript.Echo "Version: " & objItem.Version
Next

End Sub

Sub GetServiceStatus(strSrv)
On Error Resume Next
Set objWMIService = GetObject("winmgmts://" & strSrv)
strQuery="Select displayname,startmode,status,state from Win32_service " &_
"where displayname LIKE 'Microsoft Exchange%'"

Set colSvcs=objWMIService.ExecQuery(strQuery,,48)

For Each svc In colSvcs
 WScript.Echo svc.DisplayName & vbTab & svc.state & vbTab &_
  svc.startmode    
Next

End Sub

Sub SGReport(strServer,strSG)
Dim iServer
Dim iSGs
Dim iMBS

Set iServer=CreateObject("CDOEXM.ExchangeServer")
Set iSGs=CreateObject("CDOEXM.StorageGroup")
Set iMBS=CreateObject("CDOEXM.MailboxStoreDB")
iServer.DataSource.Open strServer

arrSGs=iServer.StorageGroups

For i=0 To UBound(arrSGs)
 strSGUrl=arrSGs(i)
 'WScript.Echo strSGUrl
 If InStr(UCase(strSGUrl),UCase(strSG)) Then
  iSGs.DataSource.Open "LDAP://" & iServer.DirectoryServer &_
   "/" & strSGUrl
  'strData=strData & iSGs.Name & VbCrLf
  WScript.Echo vbTab & "LogPath: " &iSGs.LogFilePath
  WScript.Echo vbTab & "SystemPath:" & iSGs.SystemFilePath 
  WScript.Echo "  MailBox Stores:"
  arrMBStores=iSGs.MailboxStoreDBs
  For j=0 To UBound(arrMBStores)
   iMBS.DataSource.open "LDAP://" & arrMBStores(j) 
   WScript.Echo  vbTab & iMBS.Name 
   WScript.Echo  vbTab & " DBPath:" & iMBS.DBPath
   WScript.Echo  vbTab & " StreamingPath:" & iMBS.SLVPath 
   WScript.Echo  vbTab & " Last Backup:" & iMBS.LastFullBackupTime
   WScript.Echo  vbTab & " StorageQuotaWarning:" & iMBS.StoreQuota 
   WScript.Echo  vbTab & " StorageQuotaLimit:" & iMBS.OverQuotaLimit 
   ListMailboxes iMBS.Name
  Next
 End If
Next
End Sub

Sub ListMailboxes(strMailStore)
On Error Resume Next
Dim objRootDSE
Dim objConfiguration
Dim conn
Dim cmd
Dim RS

Set objRootDSE = GetObject("LDAP://rootDSE")
strConfiguration = "LDAP://" & objRootDSE.Get("configurationNamingContext")
Set objConfiguration = GetObject(strConfiguration)
strPath=objConfiguration.ADSpath

strQuery="Select distinguishedname,name,homeMDBBL from '" & strPath &_
"' WHERE objectclass='msExchPrivateMDB' AND name='" & strMailStore & "'"  

set cat=GetObject("GC:")
for each objcat in cat
 set GC=objcat
Next

set conn=CreateObject("ADODB.connection")
set cmd=CreateObject("ADODB.Command")
conn.Provider="ADSDSOObject"
conn.Open   
set cmd.ActiveConnection=conn
set RS=conn.Execute(strQuery)

do while not RS.EOF
 WScript.Echo RS.Fields("distinguishedname")
 WScript.Echo vbTab & "Mailboxes on " & RS.Fields("name")
 tmpArray=RS.Fields("homeMDBBL")
 For m=0 To UBound(tmpArray)
     WScript.Echo vbTab & " " & tmpArray(m)
 Next
 RS.movenext
Loop
rs.Close
conn.Close  

End Sub

Sub GetQueueInfo(strSrv)
On Error Resume Next
Set objWMIService = GetObject("winmgmts:\\" & strSrv &_
 "\root\MicrosoftExchangev2")
strQuery="Select * from Exchange_Queue"
Set colItems = objWMIService.ExecQuery(strQuery,,48)

wscript.Echo "Queue (Protocol)" & vbTab & "Size (MsgCount)"

For Each objItem In colItems
wscript.Echo objItem.LinkName & "(" & objItem.ProtocolName & ")" &_
vbTab & FormatNumber(objItem.Size/1024,2) & "(" &_
 objItem.MessageCount & ")"   
Next

End Sub

Sub GetPublicFolderInfo(strComputer,UserName,Password)
On Error Resume Next
Dim objWMIService
Dim propValue
Dim objItem
Dim SWBemlocator
Dim colItems

Set SWBemlocator = CreateObject("WbemScripting.SWbemLocator")
Set objWMIService = SWBemlocator.ConnectServer(strComputer,_
"\root\microsoftexchangev2",UserName,Password)
strQuery="Select * from Exchange_PublicFolder"
Set colItems = objWMIService.ExecQuery(strQuery,,48)
For Each objItem in colItems
 WScript.Echo "AddressBookName: " & objItem.AddressBookName
 WScript.Echo "CreationTime: " & ConvertTime(objItem.CreationTime)
 WScript.Echo "DeletedItemLifetime: " & objItem.DeletedItemLifetime
 WScript.Echo "Description: " & objItem.Description
 WScript.Echo "FolderTree: " & objItem.FolderTree
 WScript.Echo "FriendlyUrl: " & objItem.FriendlyUrl
 WScript.Echo "HasChildren: " & objItem.HasChildren
 WScript.Echo "HasLocalReplica: " & objItem.HasLocalReplica
 WScript.Echo "InstallDate: " & ConvertTime(objItem.InstallDate)
 WScript.Echo "IsMailEnabled: " & objItem.IsMailEnabled
 WScript.Echo "IsNormalFolder: " & objItem.IsNormalFolder
 WScript.Echo "IsSecureInSite: " & objItem.IsSecureInSite
 WScript.Echo "LastAccessTime: " & ConvertTime(objItem.LastAccessTime)
 WScript.Echo "LastModificationTime: " &_
  ConvertTime(objItem.LastModificationTime)
 WScript.Echo "MaximumItemSize: " & objItem.MaximumItemSize
 WScript.Echo "MessageCount: " & objItem.MessageCount
 WScript.Echo "MessageWithAttachmentsCount: " &_
  objItem.MessageWithAttachmentsCount
 WScript.Echo "Name: " & objItem.Name
 WScript.Echo "NormalMessageSize: " & objItem.NormalMessageSize
 WScript.Echo "OwnerCount: " & objItem.OwnerCount
 WScript.Echo "ParentFriendlyUrl: " & objItem.ParentFriendlyUrl
 WScript.Echo "Path: " & objItem.Path
 WScript.Echo "ProhibitPostLimit: " & objItem.ProhibitPostLimit
 WScript.Echo "PublishInAddressBook: " & objItem.PublishInAddressBook
 WScript.Echo "ReplicaAgeLimit: " & objItem.ReplicaAgeLimit
 for each propValue in objItem.ReplicaList
     WScript.Echo "ReplicaList: " & propValue
 Next
 WScript.Echo "ReplicationMessagePriority: " &_
  objItem.ReplicationMessagePriority
 for each propValue in objItem.ReplicationSchedule
     WScript.Echo "ReplicationSchedule: " & propValue
 Next
 WScript.Echo "ReplicationStyle: " & objItem.ReplicationStyle
 WScript.Echo "RestrictionCount: " & objItem.RestrictionCount
 for each propValue in objItem.SecurityDescriptor
     WScript.Echo "SecurityDescriptor: " & propValue
 Next
 WScript.Echo "Status: " & objItem.Status
 WScript.Echo "StorageLimitStyle: " & objItem.StorageLimitStyle
 WScript.Echo "TotalMessageSize: " & objItem.TotalMessageSize
 WScript.Echo "Url: " & objItem.Url
 WScript.Echo "UsePublicStoreAgeLimits: " &_
  objItem.UsePublicStoreAgeLimits
 WScript.Echo "UsePublicStoreDeletedItemLifetime: " &_
  objItem.UsePublicStoreDeletedItemLifetime
 WScript.Echo "WarningLimit: " & objItem.WarningLimit
 WScript.Echo VbCrLf
Next
End Sub