'-------------------------------------------------------------------
' <company>Microsoft Corporation</company>
' <copyright>Copyright (c) Microsoft Corporation. All rights reserved.
' </copyright>
' <name>
'  IIS Role Discovery
' </name>
' <summary>
'  Creates an IIS server role for this computer
' </summary>
'-------------------------------------------------------------------

Option Explicit

Const COMPUTER_CLASS_ID = "Computer"

Const COMPUTER_COMPUTER_NAME_ATTRIBUTE_ID = "ComputerName"
Const COMPUTER_TIME_ZONE_BIAS_ATTRIBUTE_ID = "Time Zone Bias"
Const COMPUTER_OPERATING_SYSTEM_VERSION_ATTRIBUTE_ID =_
  "Operating System Version"
Const COMPUTER_IP_ADDRESS_ATTRIBUTE_ID = "IPAddress"
Const COMPUTER_FQDN_ATTRIBUTE_ID = "FQDN"
Const COMPUTER_VIRTUAL_SERVER_TYPE_ATTRIBUTE_ID = "Virtual Server Type"

Sub Main()
  Dim oDiscData
  Dim oCollection
  Dim oInstance

  Set oDiscData = ScriptContext.CreateDiscoveryData()
  Set oCollection = oDiscData.CreateCollection()
  oCollection.AddScopeFilter COMPUTER_COMPUTER_NAME_ATTRIBUTE_ID,_
   ScriptContext.TargetComputerIdentity
  oCollection.ClassID = "IIS"

  Set oInstance = oCollection.CreateInstance()
  oInstance.AddKeyProperty "Server Name",_
   ScriptContext.TargetNetbiosComputer
  oCollection.AddInstance oInstance
  oDiscData.AddCollection oCollection

  ScriptContext.Submit oDiscData
End Sub