strFolder=ScriptContext.Parameters.Get("folder")
iThreshold=ScriptContext.Parameters.Get("Threshold")
iSize=GetFolderSize(strFolder)

If Int(iSize)>Int(iThreshold) Then 
'folder size exceeds Threshold so generate an alert
ScriptContext.Echo "Alert!"
strDescription=strFolder & " has exceeded the specified Threshold of " &_
 FormatNumber(iThreshold,0,True) & " bytes.  Folder size is " &_
 FormatNumber(iSize,0,True) & " bytes"
ScriptContext.echo strDescription
CreateAlert "Folder Size Exceeded",20,"[unassigned]",0,strDescription
Else
'folder size is OK
'write data to MOM event
ScriptContext.Echo strFolder & " is OK. Size=" & FormatNumber(iSize,0,True) & " bytes"
End If

'create perfdata
CreatePerfData "Monitored Folder","FolderSize",strFolder,FormatNumber((iSize/1024000),2)

Function GetFolderSize(strFolder)
  dim objFSO,objFldr
  set objFSO=CreateObject("Scripting.FileSystemObject")
  set objFldr=objFSO.GetFolder(strFolder)
  GetFolderSize=objFldr.Size
End Function

Sub CreateAlert(strObjectName,iAlertLevel,strOwner,iResolutionState,strDescription)
  'Create the Alert object
  Set objCreatedAlert = ScriptContext.CreateAlert()
  'Set Alert properties
  objCreatedAlert.Name = strObjectName
  objCreatedAlert.AlertLevel = iAlertLevel
  objCreatedAlert.Owner = strOwner
  objCreatedAlert.ResolutionState = iResolutionState 
  objCreatedAlert.Description=strDescription
  'Submit the Alert object to MOM
  ScriptContext.Submit objCreatedAlert
End Sub

Sub CreatePerfData(strObjectName,strCounterName,strInstanceName,numValue)
  'Create the PerfData object
  Set objPerfData = ScriptContext.CreatePerfData
  'Set PerfData properties
  objPerfData.ObjectName = strObjectName
  objPerfData.CounterName =strCounterName
  objPerfData.InstanceName = strInstanceName
  objPerfData.Value = numValue
  'Submit the PerfData object to MOM
  ScriptContext.Submit objPerfData
End Sub
